#ifndef LINECLIENT_H
#define LINECLIENT_H

#include <string>

// This is a simple socket client class that is
// used to send and receive one line at a time.

class LineClient
{
public:
	LineClient();
	~LineClient();

	bool init();

	bool connected() { return (m_socket != -1 && m_connected); }
	bool connect(const std::string& host, int port);
	bool disconnect();

	bool hasLine() { return (m_index2 != m_index1); }
	bool sendLine(const std::string& line);
	bool getLine(std::string* line);
	
private:
	enum { LINE_BUFSIZE = 10000 };

	static void* static_listenloop(void* line_client);
	void listenloop();

	void addLine(const std::string& line);
	
	int m_socket;
	bool m_shutdown;
	bool m_connected;
	int m_index1;     // Index of line that is ready if m_index1 < m_index2.
	int m_index2;     // Index of line that is being read from the server.
	std::string	m_line[LINE_BUFSIZE];  // Buffer of lines received from server.
};

#endif
